unit Arhivacija;

interface

procedure SaveConfig;
procedure ReadConfig;
procedure Write_zip(num:word(*  *));
procedure Write_zip_ust;
procedure Zagruz_Zapis;
Function sravnenie:boolean;

implementation

uses Glav,DateUtils,SysUtils,IniFiles,Forms,Dialogs;
var nn:word;  //   


// ------------.   

procedure SaveConfig;
var
 RegKey: TIniFile;
begin
  RegKey := TIniFile.Create(CurrentPath+Application.Title+'.INI');
 with RegKey do
  begin
   WriteInteger('General','COM port',InitCOM);
      //  -
   WriteFloat('koof','C0_1',C0_1);
   WriteFloat('koof','C1_1',C1_1);
   WriteFloat('koof','C2_1',C2_1);

   WriteFloat('koof','C0_2',C0_2);
   WriteFloat('koof','C1_2',C1_2);
   WriteFloat('koof','C2_2',C2_2);

       //    
   WriteFloat('term','otkl_A1',otkl_A1);
   WriteFloat('term','otkl_B1',otkl_B1);
   WriteFloat('term','otkl_A2',otkl_A2);
   WriteFloat('term','otkl_B2',otkl_B2);
   WriteFloat('term','otkl_C2',otkl_C2);
   WriteFloat('term','otkl_A3',otkl_A3);
   WriteFloat('term','otkl_B3',otkl_B3);

   WriteFloat('term','skor_A1',skor_A1);
   WriteFloat('term','skor_B1',skor_B1);
   WriteFloat('term','skor_A2',skor_A2);
   WriteFloat('term','skor_B2',skor_B2);
   WriteFloat('term','skor_C2',skor_C2);
   WriteFloat('term','skor_A3',skor_A3);
   WriteFloat('term','skor_B3',skor_B3);

     //    
   WriteFloat('koof','otkl_left',otkl_left);
   WriteFloat('koof','otkl_right',otkl_right);
   WriteFloat('koof','skor_left',skor_left);
   WriteFloat('koof','skor_right',skor_right);

         // 
   WriteInteger('term_out','vih_1',vih_1);
   WriteInteger('term_out','vih_2',vih_2);
   WriteInteger('term_out','vih_3',vih_3);
   WriteInteger('term_out','vih_4',vih_4);
   WriteInteger('term_out','vih_5',vih_5);
   WriteInteger('term_out','vih_6',vih_6);
   WriteInteger('term_out','vih_7',vih_7);
   WriteInteger('term_out','vih_8',vih_8);
   WriteInteger('term_out','vih_9',vih_9);

      //  
   WriteInteger('baza','m1',m1);
   WriteInteger('baza','m2',m2);
   WriteInteger('baza','m3',m3);
   WriteInteger('baza','m4',m4);
   WriteInteger('baza','m5',m5);
   WriteInteger('baza','m6',m6);
   WriteInteger('baza','m7',m7);
   WriteInteger('baza','m8',m8);
   WriteInteger('baza','m9',m9);

      // . 
   WriteBool('check','prop_1',F_Glav.Check_Reg1_Prop.Checked);
   WriteBool('check','integ_1',F_Glav.Check_Reg1_Integ.Checked);
   WriteBool('check','diff_1',F_Glav.Check_Reg1_Diff.Checked);

   WriteBool('check','prop_2',F_Glav.Check_Reg2_Prop.Checked);
   WriteBool('check','integ_2',F_Glav.Check_Reg2_Integ.Checked);
   WriteBool('check','diff_2',F_Glav.Check_Reg2_Diff.Checked);

  Free;
  end;
end;

(**********      *)

procedure ReadConfig;
var
 RegKey: TIniFile;
begin
RegKey := TIniFile.Create(CurrentPath+Application.Title+'.INI');
try
 with RegKey do
  begin
   InitCOM:=ReadInteger('General','COM port',1);
      //  -
   C0_1:=ReadFloat('koof','C0_1',20);
   C1_1:=ReadFloat('koof','C1_1',0.2);
   C2_1:=ReadFloat('koof','C2_1',2);

   C0_2:=ReadFloat('koof','C0_2',10);
   C1_2:=ReadFloat('koof','C1_2',0.12);
   C2_2:=ReadFloat('koof','C2_2',22);

     //    
   otkl_A1:=ReadFloat('term','otkl_A1',3);
   otkl_B1:=ReadFloat('term','otkl_B1',0);
   otkl_A2:=ReadFloat('term','otkl_A2',3);
   otkl_B2:=ReadFloat('term','otkl_B2',0);
   otkl_C2:=ReadFloat('term','otkl_C2',3);
   otkl_A3:=ReadFloat('term','otkl_A3',0);
   otkl_B3:=ReadFloat('term','otkl_B3',3);

   skor_A1:=ReadFloat('term','skor_A1',1);
   skor_B1:=ReadFloat('term','skor_B1',0);
   skor_A2:=ReadFloat('term','skor_A2',1);
   skor_B2:=ReadFloat('term','skor_B2',0);
   skor_C2:=ReadFloat('term','skor_C2',1);
   skor_A3:=ReadFloat('term','skor_A3',0);
   skor_B3:=ReadFloat('term','skor_B3',1);

     //    
   otkl_left:=ReadFloat('koof','otkl_left',33);
   otkl_right:=ReadFloat('koof','otkl_right',33);
   skor_left:=ReadFloat('koof','skor_left',11);
   skor_right:=ReadFloat('koof','skor_right',11);

       // 
   vih_1:=ReadInteger('term_out','vih_1',5);
   vih_2:=ReadInteger('term_out','vih_2',15);
   vih_3:=ReadInteger('term_out','vih_3',50);
   vih_4:=ReadInteger('term_out','vih_4',70);
   vih_5:=ReadInteger('term_out','vih_5',90);
   vih_6:=ReadInteger('term_out','vih_6',120);
   vih_7:=ReadInteger('term_out','vih_7',155);
   vih_8:=ReadInteger('term_out','vih_8',170);
   vih_9:=ReadInteger('term_out','vih_9',190);

      //  
   m1:=ReadInteger('baza','m1',1);
   m2:=ReadInteger('baza','m2',2);
   m3:=ReadInteger('baza','m3',4);
   m4:=ReadInteger('baza','m4',2);
   m5:=ReadInteger('baza','m5',4);
   m6:=ReadInteger('baza','m6',6);
   m7:=ReadInteger('baza','m7',4);
   m8:=ReadInteger('baza','m8',6);
   m9:=ReadInteger('baza','m9',8);

       // . 
   F_Glav.Check_Reg1_Prop.Checked:=ReadBool('check','prop_1',False);
   F_Glav.Check_Reg1_Integ.Checked:=ReadBool('check','integ_1',False);
   F_Glav.Check_Reg1_Diff.Checked:=ReadBool('check','diff_1',True);


   F_Glav.Check_Reg2_Prop.Checked:=ReadBool('check','prop_2',True);
   F_Glav.Check_Reg2_Integ.Checked:=ReadBool('check','integ_2',True);
   F_Glav.Check_Reg2_Diff.Checked:=ReadBool('check','diff_2',True);
   Free;
  end;
 except
 end;
end;

(***********   *************)
Function sravnenie:boolean;
begin


 if
     // 
   (MasKoofInfo.zadan <> Zadanie) or
    //  -
   (MasKoofInfo.Cz0_1 <> C0_1) or
   (MasKoofInfo.Cz1_1 <> C1_1) or
   (MasKoofInfo.Cz2_1 <> C2_1) or
   (MasKoofInfo.Cz0_2 <> C0_2) or
   (MasKoofInfo.Cz1_2 <> C1_2) or
   (MasKoofInfo.Cz2_2 <> C2_2) or


    //  FUZZY
    //    
   (MasKoofInfo.zotkl_left <> otkl_left) or
   (MasKoofInfo.zotkl_right <> otkl_right) or
   (MasKoofInfo.zskor_left <> skor_left) or
   (MasKoofInfo.zskor_right <> skor_right) or

    //  
    (MasKoofInfo.m1z <> m1) or
    (MasKoofInfo.m2z <> m2) or
    (MasKoofInfo.m3z <> m3) or
    (MasKoofInfo.m4z <> m4) or
    (MasKoofInfo.m5z <> m5) or
    (MasKoofInfo.m6z <> m6) or
    (MasKoofInfo.m7z <> m7) or
    (MasKoofInfo.m8z <> m8) or
    (MasKoofInfo.m9z <> m9) or

         //    
    (MasKoofInfo.zotkl_A1 <> otkl_A1) or
    (MasKoofInfo.zotkl_B1 <> otkl_B1) or
    (MasKoofInfo.zotkl_A2 <> otkl_A2) or
    (MasKoofInfo.zotkl_B2 <> otkl_B2) or
    (MasKoofInfo.zotkl_C2 <> otkl_C2) or
    (MasKoofInfo.zotkl_A3 <> otkl_A3) or
    (MasKoofInfo.zotkl_B3 <> otkl_B3) or


    (MasKoofInfo.zskor_A1 <> skor_A1) or
    (MasKoofInfo.zskor_B1 <> skor_B1) or
    (MasKoofInfo.zskor_A2 <> skor_A2) or
    (MasKoofInfo.zskor_B2 <> skor_B2) or
    (MasKoofInfo.zskor_C2 <> skor_C2) or
    (MasKoofInfo.zskor_A3 <> skor_A3) or
    (MasKoofInfo.zskor_B3 <> skor_B3) or

       // 
   (MasKoofInfo.zvih_1 <> vih_1) or
   (MasKoofInfo.zvih_2 <> vih_2) or
   (MasKoofInfo.zvih_3 <> vih_3) or
   (MasKoofInfo.zvih_4 <> vih_4) or
   (MasKoofInfo.zvih_5 <> vih_5) or
   (MasKoofInfo.zvih_6 <> vih_6) or
   (MasKoofInfo.zvih_7 <> vih_7) or
   (MasKoofInfo.zvih_8 <> vih_8) or
   (MasKoofInfo.zvih_9 <> vih_9) or

   (MasKoofInfo.znagrev <> nagrev) or



       // . 
   (MasKoofInfo.zCheck_Reg1_Prop <> F_Glav.Check_Reg1_Prop.Checked) or
   (MasKoofInfo.zCheck_Reg1_Integ <> F_Glav.Check_Reg1_Integ.Checked) or
   (MasKoofInfo.zCheck_Reg1_Diff <> F_Glav.Check_Reg1_Diff.Checked) or

   (MasKoofInfo.zCheck_Reg2_Prop <> F_Glav.Check_Reg2_Prop.Checked) or
   (MasKoofInfo.zCheck_Reg2_Integ <> F_Glav.Check_Reg2_Integ.Checked) or
   (MasKoofInfo.zCheck_Reg2_Diff <> F_Glav.Check_Reg2_Diff.Checked) or

   (MasKoofInfo.zCheck_Fuzzy <> F_Glav.Check_Fuzzy.Checked) or
   (MasKoofInfo.zCheck_PID <> F_Glav.Check_PID.Checked)  or
   (MasKoofInfo.zSkorost <> F_Glav.Timer1.Interval)

     then   sravnenie:=true
     else sravnenie:=false;
end;

(***********  .  *************)
procedure Zagruz_Zapis;
begin

     //  
    MasKoofInfo.izm_n:=Num_Izm;
   // 
    MasKoofInfo.zadan:=Zadanie;
    //  -
    MasKoofInfo.Cz0_1:=C0_1;
    MasKoofInfo.Cz1_1:=C1_1;
    MasKoofInfo.Cz2_1:=C2_1;
    MasKoofInfo.Cz0_2:=C0_2;
    MasKoofInfo.Cz1_2:=C1_2;
    MasKoofInfo.Cz2_2:=C2_2;

    //  FUZZY
    //    
    MasKoofInfo.zotkl_left:=otkl_left;
    MasKoofInfo.zotkl_right:=otkl_right;
    MasKoofInfo.zskor_left:=skor_left;
    MasKoofInfo.zskor_right:=skor_right;

    //  
    MasKoofInfo.m1z:=m1;
    MasKoofInfo.m2z:=m2;
    MasKoofInfo.m3z:=m3;
    MasKoofInfo.m4z:=m4;
    MasKoofInfo.m5z:=m5;
    MasKoofInfo.m6z:=m6;
    MasKoofInfo.m7z:=m7;
    MasKoofInfo.m8z:=m8;
    MasKoofInfo.m9z:=m9;

         //    
    MasKoofInfo.zotkl_A1:=otkl_A1;
    MasKoofInfo.zotkl_B1:=otkl_B1;
    MasKoofInfo.zotkl_A2:=otkl_A2;
    MasKoofInfo.zotkl_B2:=otkl_B2;
    MasKoofInfo.zotkl_C2:=otkl_C2;
    MasKoofInfo.zotkl_A3:=otkl_A3;
    MasKoofInfo.zotkl_B3:=otkl_B3;


    MasKoofInfo.zskor_A1:=skor_A1;
    MasKoofInfo.zskor_B1:=skor_B1;
    MasKoofInfo.zskor_A2:=skor_A2;
    MasKoofInfo.zskor_B2:=skor_B2;
    MasKoofInfo.zskor_C2:=skor_C2;
    MasKoofInfo.zskor_A3:=skor_A3;
    MasKoofInfo.zskor_B3:=skor_B3;

       // 
   MasKoofInfo.zvih_1:=vih_1;
   MasKoofInfo.zvih_2:=vih_2;
   MasKoofInfo.zvih_3:=vih_3;
   MasKoofInfo.zvih_4:=vih_4;
   MasKoofInfo.zvih_5:=vih_5;
   MasKoofInfo.zvih_6:=vih_6;
   MasKoofInfo.zvih_7:=vih_7;
   MasKoofInfo.zvih_8:=vih_8;
   MasKoofInfo.zvih_9:=vih_9;



       // . 
   MasKoofInfo.zCheck_Reg1_Prop:=F_Glav.Check_Reg1_Prop.Checked;
   MasKoofInfo.zCheck_Reg1_Integ:=F_Glav.Check_Reg1_Integ.Checked;
   MasKoofInfo.zCheck_Reg1_Diff:=F_Glav.Check_Reg1_Diff.Checked;

   MasKoofInfo.zCheck_Reg2_Prop:=F_Glav.Check_Reg2_Prop.Checked;
   MasKoofInfo.zCheck_Reg2_Integ:=F_Glav.Check_Reg2_Integ.Checked;
   MasKoofInfo.zCheck_Reg2_Diff:=F_Glav.Check_Reg2_Diff.Checked;

   MasKoofInfo.zCheck_Fuzzy:=F_Glav.Check_Fuzzy.Checked;
   MasKoofInfo.zCheck_PID:=F_Glav.Check_PID.Checked;
   MasKoofInfo.znagrev:=nagrev;
   MasKoofInfo.zSkorost:=F_Glav.Timer1.Interval;
end;
  (**************************************)
 (**********   *********************)
procedure Write_zip(num:word(*  *));
var
 ii:word;
 j: integer;
fZipName: String[80];
   FZip : file of  TrecTemperVremya;  //   -  
begin


  MasTV[num].Vremya:=Time;
  MasTV[num].temper:=Temperatura;
  MasTV[num].In_SUM1:=SUM1;
  MasTV[num].In_SUM2:=SUM2;
    (*-----------------------------------------------*)

    fZipName := FName;
    AssignFile(fzip, fZipName);

   if not FileExists( fZipName )  then
     Rewrite(fzip)  //  
    else
        begin
         Reset(fzip);  //  
         Seek( fzip, FileSize(fzip))
        end; //   

 (*----------------------------------------------*)

       write(fzip,MasTV[num] ); //      

       CloseFile( fzip );  //  }

end;

(******************************************)
(**********   ****************)

procedure Write_zip_ust;
var
j: integer;
 Ust_fzip: file of TMasKoofInfo;//   -  
 fZipName: String[80];


begin
  Zagruz_Zapis;
(*----------------------------------------------*)
    fZipName := FName+'UST';
    AssignFile(Ust_fzip,fZipName);

      if not FileExists( fZipName )  then
     Rewrite(Ust_fzip)  //  
    else
        begin
         Reset(Ust_fzip);  //  
         Seek( Ust_fzip, FileSize(Ust_fzip))
        end; //   

(*----------------------------------------------*)

      write(Ust_fzip,  MasKoofInfo); //    
      CloseFile( Ust_fzip );  //  

end;

(******************************************)
end.
