unit zFuzzy_Pid;

interface

Function zPID(mm:integer; xj:word):Real;
Function zFuzzy(mm:integer; xj:word):real;

implementation

uses Arhiv,Graphics,SysUtils;


 var
  M_pid1:byte=1;{}

  E1_1:REAL;
   SUM1,SUM2,Vihod,Vihod_Reg1,Vihod_Reg2:REAL;
(*========================================*)

  (*********    ***********************)
{ E    }
{ E1     }
{ M:INT;{ }
{        =1}
{ U:REAL;{  }
  { P -  C0}
  { I -      C1 }
  { D -  C2  }

  {}
{U=U1-C0*E+C1*E1+C2*E2
C0=Ku*(1+Td/T0)
C1=Ku*(1+2Td/T0-T0/Ti)
C2=Ku*Td/T0    }

{* PID subprogram, call cyclically *}
Function zPID(mm:integer; xj:word):Real;
  var
 U:REAL;{ 2}

BEGIN
 U:=0;
 SUM2:=ZipTV[xj].ZipIn_SUM2;

 if SUM2>1000000 then
 begin SUM2:=1000000; end;

if F_Arhiv.Check_Reg2_Prop.Checked=True then
    begin
      U:=U+ZipKoof[mm].Cz0_2*(ZipKoof[mm].zadan-ZipTV[xj].ZipTemper);
      F_Arhiv.Ind_Reg2_Prop.Caption:= formatFloat('0.00',(0.427*ZipKoof[mm].Cz0_2*(ZipKoof[mm].zadan-
                                               ZipTV[xj].ZipTemper)));
    end;
(*----------------------------*)
if F_Arhiv.Check_Reg2_Integ.Checked=True then
    begin
      U:=U+ZipKoof[mm].Cz1_2*SUM2;
      F_Arhiv.Ind_Reg2_Integ.Caption:=formatFloat('0.00',(0.427*ZipKoof[mm].Cz1_2*SUM2));
    end;
(*----------------------------*)
if F_Arhiv.Check_Reg2_Diff.Checked=True then
    begin
       U:=U+ZipKoof[mm].Cz2_2*((ZipKoof[mm].zadan-ZipTV[xj].ZipTemper)-
                        (ZipKoof[mm].zadan-ZipTV[xj-1].ZipTemper));
       F_Arhiv.Ind_Reg2_Diff.Caption:= formatFloat('0.00',(0.427*ZipKoof[mm].Cz2_2*
      ((ZipKoof[mm].zadan-ZipTV[xj].ZipTemper)-(ZipKoof[mm].zadan-ZipTV[xj-1].ZipTemper))));
    end;
(*----------------------------*)
  zPID:=U;
END;
(*************************************)

 (*************************************)
procedure zTablica( ij:integer);
 begin
  if (ij and 1)=1 then F_Arhiv.MaskEdit1.Color:=clGreen
  else   F_Arhiv.MaskEdit1.Color:=clWindow;

  if (ij and 2)=2 then F_Arhiv.MaskEdit2.Color:=clGreen
  else   F_Arhiv.MaskEdit2.Color:=clWindow;

  if (ij and 4)=4 then F_Arhiv.MaskEdit3.Color:=clGreen
  else   F_Arhiv.MaskEdit3.Color:=clWindow;

  if (ij and 8)=8 then F_Arhiv.MaskEdit4.Color:=clGreen
  else   F_Arhiv.MaskEdit4.Color:=clWindow;

  if (ij and 16)=16 then F_Arhiv.MaskEdit5.Color:=clGreen
  else   F_Arhiv.MaskEdit5.Color:=clWindow;

  if (ij and 32)=32 then F_Arhiv.MaskEdit6.Color:=clGreen
  else   F_Arhiv.MaskEdit6.Color:=clWindow;

  if (ij and 64)=64 then F_Arhiv.MaskEdit7.Color:=clGreen
  else   F_Arhiv.MaskEdit7.Color:=clWindow;

  if (ij and 128)=128 then F_Arhiv.MaskEdit8.Color:=clGreen
  else   F_Arhiv.MaskEdit8.Color:=clWindow;

  if (ij and 256)=256 then F_Arhiv.MaskEdit9.Color:=clGreen
  else   F_Arhiv.MaskEdit9.Color:=clWindow;

  end;


{*****************************************}

{*****************************************}
Function zFuzzy(mm:integer; xj:word):real;
var
 Tem_dat: array [0..22] of extended;
 jach_T: array [0..22] of byte;
 jach_My: array [0..22] of real;
 ja_T_rez: array [0..22] of byte;
 ja_My_rez: array [0..22] of real;

  num_jach_prinad,num,ii:byte;
  i,T_cel,T_sot,Temp,Vib_jach:integer;
  my,my1,my2,my3,my4,my5,my_mal_skor,my_norm_skor,my_bol_skor,
  my_mal_otkl,my_norm_otkl,my_bol_otkl, my_min1,my_min2,my_min3,my_min4,
  my_min5,my_min6,my_min7,my_min8,my_min9,max,P_temp,P: real;

 U:REAL;{ }
 E:REAL;
 E_dif,pos_skor,pos_otklon:real;

 U_out:REAL;{  }
  (****************************************)


 begin
U:=0;
SUM1:=ZipTV[xj].ZipIn_SUM1;
 if SUM1>1000000 then
 begin SUM1:=1000000; end;

if ZipKoof[mm].zCheck_Reg1_Prop=True then
    begin
      U:=U+ZipKoof[mm].Cz0_1*(ZipKoof[mm].zadan-ZipTV[xj].ZipTemper);
      F_Arhiv.Ind_Reg1_Prop.Caption:= formatFloat('0.00',(0.427*ZipKoof[mm].Cz0_1*(ZipKoof[mm].zadan-
                                               ZipTV[xj].ZipTemper)));
    end;
(*----------------------------*)
if F_Arhiv.Check_Reg1_Integ.Checked=True then
    begin
      U:=U+ZipKoof[mm].Cz1_1*SUM2;
      F_Arhiv.Ind_Reg1_Integ.Caption:=formatFloat('0.00',(0.427*ZipKoof[mm].Cz1_1*SUM1));
    end;
(*----------------------------*)
if F_Arhiv.Check_Reg1_Diff.Checked=True then
    begin
       U:=U+ZipKoof[mm].Cz2_1*((ZipKoof[mm].zadan-ZipTV[xj].ZipTemper)-
                        (ZipKoof[mm].zadan-ZipTV[xj-1].ZipTemper));
       F_Arhiv.Ind_Reg1_Diff.Caption:= formatFloat('0.00',(0.427*ZipKoof[mm].Cz2_1*
      ((ZipKoof[mm].zadan-ZipTV[xj].ZipTemper)-(ZipKoof[mm].zadan-ZipTV[xj-1].ZipTemper))));
    end;
(*----------------------------*)



////////////////////////////////////////////////////////
     //  

F_Arhiv.Chart2.SeriesList[0].Clear;
F_Arhiv.Chart2.SeriesList[1].Clear;
F_Arhiv.Chart2.SeriesList[2].Clear;
F_Arhiv.Chart2.SeriesList[3].Clear;
F_Arhiv.Chart1.SeriesList[0].Clear;
F_Arhiv.Chart1.SeriesList[1].Clear;
F_Arhiv.Chart1.SeriesList[2].Clear;
F_Arhiv.Chart1.SeriesList[3].Clear;

////////////////////////////////////////////////////////

   pos_otklon:= ZipKoof[mm].zadan-ZipTV[xj].ZipTemper;
   
 pos_skor:=((ZipKoof[mm].zadan-ZipTV[xj].ZipTemper)-
              (ZipKoof[mm].zadan-ZipTV[xj-1].ZipTemper)); //    


   if pos_otklon > ZipKoof[mm].zotkl_right/10 then pos_otklon:=ZipKoof[mm].zotkl_right/10;
if pos_otklon <(-1*ZipKoof[mm].zotkl_left/10) then pos_otklon:=(-1*ZipKoof[mm].zotkl_left/10);


   if pos_skor > ZipKoof[mm].zskor_right/10 then pos_skor:=ZipKoof[mm].zskor_right/10;
if pos_skor <(-1*ZipKoof[mm].zskor_left/10) then pos_skor:=(-1*ZipKoof[mm].zskor_left/10);


         //   
        F_Arhiv.Chart1.SeriesList[0].AddXY((pos_otklon),0);//  
        F_Arhiv.Chart1.SeriesList[0].AddXY((pos_otklon),1); // 

          //   
        F_Arhiv.Chart2.SeriesList[0].AddXY((pos_skor),0);//  
        F_Arhiv.Chart2.SeriesList[0].AddXY((pos_skor),1);// 


 //      

  for i:= round(-1*ZipKoof[mm].zotkl_left) to round(ZipKoof[mm].zotkl_right) do

  begin
  if i/10 <= (-1*ZipKoof[mm].zotkl_A1) then begin my:=1;  end;
  if (i/10 > (-1*ZipKoof[mm].zotkl_A1)) and (i/10<=(-1*ZipKoof[mm].zotkl_B1)) then
      begin my:=(((-1*ZipKoof[mm].zotkl_B1)-i/10)/((-1*ZipKoof[mm].zotkl_B1)-
      (-1*ZipKoof[mm].zotkl_A1))); end;
  if i >(-1*ZipKoof[mm].zotkl_B1) then  begin my:=0; end;

     F_Arhiv.Chart1.SeriesList[1].AddXY(i/10,(my),FloatToStr(i/10));
  (*------------------------------------------*)

  if i/10 <= (-1*ZipKoof[mm].zotkl_A2) then  begin my1:=0; end;
  if (i/10 > (-1*ZipKoof[mm].zotkl_A2)) and (i/10<= (ZipKoof[mm].zotkl_B2)) then
   begin my1:=((i/10-(-1*ZipKoof[mm].zotkl_A2))/(-1*ZipKoof[mm].zotkl_B2-
   (-1*ZipKoof[mm].zotkl_A2)));  end;
  if (i/10 > (-1*ZipKoof[mm].zotkl_B2)) and (i/10<= ZipKoof[mm].zotkl_C2) then
   begin my1:=((ZipKoof[mm].zotkl_C2-i/10)/(ZipKoof[mm].zotkl_C2-ZipKoof[mm].zotkl_B2));    end;
  if i/10 > ZipKoof[mm].zotkl_C2 then  begin my1:=0;  end;

     F_Arhiv.Chart1.SeriesList[2].AddXY(i/10,(my1),FloatToStr(i/10));

      (*------------------------------------------*)
  if i/10 <= ZipKoof[mm].zotkl_A3 then begin my2:=0; end;
  if (i/10 > ZipKoof[mm].zotkl_A3) and (i/10<=ZipKoof[mm].zotkl_B3) then
   begin my2:=((i/10-ZipKoof[mm].zotkl_A3)/(ZipKoof[mm].zotkl_B3-ZipKoof[mm].zotkl_A3));  end;
  if i/10 >ZipKoof[mm].zotkl_B3 then begin my2:=1; end;

     F_Arhiv.Chart1.SeriesList[3].AddXY(i/10,(my2),FloatToStr(i/10));
 end;

     (**************************************************)


 //    

 for i:= round(-1*ZipKoof[mm].zskor_left) to round(ZipKoof[mm].zskor_right) do

 begin
  if i/10 <=(-1*ZipKoof[mm].zskor_A1) then my:=1;
  if (i/10 > (-1*ZipKoof[mm].zskor_A1)) and (i/10<=(-1*ZipKoof[mm].zskor_B1)) then
     my:=(((-1*ZipKoof[mm].zskor_B1)-i/10)/((-1*ZipKoof[mm].zskor_B1)-
     (-1*ZipKoof[mm].zskor_A1)));
  if i/10 >(-1*ZipKoof[mm].zskor_B1) then my:=0;

      F_Arhiv.Chart2.SeriesList[1].AddXY(i/10,(my),FloatToStr(i/10));
 (*------------------------------------------*)

  if i/10 <= (-1*ZipKoof[mm].zskor_A2)  then my1:=0;
  if (i/10 > (-1*ZipKoof[mm].zskor_A2)) and (i/10<=(-1*ZipKoof[mm].zskor_B2)) then
         my1:=((i/10-(-1*ZipKoof[mm].zskor_A2))/(-1*ZipKoof[mm].zskor_B2-
         (-1*ZipKoof[mm].zskor_A2)));
  if (i/10 > (-1*ZipKoof[mm].zskor_B2)) and (i/10<=ZipKoof[mm].zskor_C2)      then
         my1:=((ZipKoof[mm].zskor_C2-i/10)/(ZipKoof[mm].zskor_C2-
         ZipKoof[mm].zskor_B2));
  if (i/10 > (ZipKoof[mm].zskor_C2))    then my1:=0;

      F_Arhiv.Chart2.SeriesList[2].AddXY(i/10,(my1),FloatToStr(i/10));
(*------------------------------------------*)

  if i/10 <= ZipKoof[mm].zskor_A3    then my2:=0;
  if (i/10 > ZipKoof[mm].zskor_A3) and (i/10<=ZipKoof[mm].zskor_B3) then
  my2:=((i/10-ZipKoof[mm].zskor_A3)/(ZipKoof[mm].zskor_B3-ZipKoof[mm].zskor_A3));
  if i/10 >ZipKoof[mm].zskor_B3      then my2:=1;

      F_Arhiv.Chart2.SeriesList[3].AddXY(i/10,(my2),FloatToStr(i/10));
(*------------------------------------------*)
   end;



 (****************************************)
  //  ,   

  if pos_otklon <= (-1*ZipKoof[mm].zotkl_A1) then begin   my_mal_otkl:=1; end;

  if (pos_otklon > (-1*ZipKoof[mm].zotkl_A1)) and (pos_otklon<=(-1*ZipKoof[mm].zotkl_B1)) then
   begin my_mal_otkl:=(((-1*ZipKoof[mm].zotkl_B1)-pos_otklon)/((-1*ZipKoof[mm].zotkl_B1)-
                                  (-1*ZipKoof[mm].zotkl_A1)));  end;

  if pos_otklon >ZipKoof[mm].zotkl_B1 then  begin  my_mal_otkl:= 0; end;
       F_Arhiv.ind_mal_otkl.Caption:=formatFloat('0.00',(my_mal_otkl));

        (*------------------------------------------*)
  if pos_otklon <= (-1*ZipKoof[mm].zotkl_A2) then  begin  my_norm_otkl:=0; end;

  if (pos_otklon > (-1*ZipKoof[mm].zotkl_A2)) and (pos_otklon<=0) then
    begin my_norm_otkl:= ((pos_otklon-(-1*ZipKoof[mm].zotkl_A2))/(-1*ZipKoof[mm].zotkl_B2-
                                        (-1*ZipKoof[mm].zotkl_A2))); end;

  if (pos_otklon >(-1*ZipKoof[mm].zotkl_B2)) and (pos_otklon<=ZipKoof[mm].zotkl_C2) then
    begin my_norm_otkl:=((ZipKoof[mm].zotkl_C2-pos_otklon)/(ZipKoof[mm].zotkl_C2-
    ZipKoof[mm].zotkl_B2)); end;

  if pos_otklon > ZipKoof[mm].zotkl_C2 then  begin my_norm_otkl:=0; end;
      F_Arhiv.ind_norm_otkl.Caption:=formatFloat('0.00',(my_norm_otkl));
 (*------------------------------------------*)
  if pos_otklon <= ZipKoof[mm].zotkl_A3 then begin my_bol_otkl:=0; end;

  if (pos_otklon > ZipKoof[mm].zotkl_A3) and (pos_otklon<=ZipKoof[mm].zotkl_B3) then
     begin  my_bol_otkl:=((pos_otklon-ZipKoof[mm].zotkl_A3)/(ZipKoof[mm].zotkl_B3-
                                      ZipKoof[mm].zotkl_A3));  end;

  if pos_otklon >ZipKoof[mm].zotkl_B3 then begin my_bol_otkl:=1; end;
    F_Arhiv.ind_bol_otkl.Caption:=formatFloat('0.00',(my_bol_otkl));

      (*------------------------------------------*)

      //    

  if pos_skor <= (-1*ZipKoof[mm].zskor_A1) then begin   my_mal_skor:=1; end;

  if (pos_skor > (-1*ZipKoof[mm].zskor_A1)) and (pos_skor<=(-1*ZipKoof[mm].zskor_B1)) then
    begin my_mal_skor:=(((-1*ZipKoof[mm].zskor_B1)-pos_skor)/((-1*ZipKoof[mm].zskor_B1)-
                                 (-1*ZipKoof[mm].zskor_A1))); end;

  if pos_skor >(-1*ZipKoof[mm].zskor_B1) then  begin  my_mal_skor:= 0; end;
   F_Arhiv.ind_mal_skor.Caption:=formatFloat('0.00',(my_mal_skor));

 (*------------------------------------------*)
  if pos_skor <= (-1*ZipKoof[mm].zskor_A2) then  begin  my_norm_skor:=0; end;

  if (pos_skor > (-1*ZipKoof[mm].zskor_A2)) and (pos_skor<=(-1*ZipKoof[mm].zskor_B2)) then
  begin my_norm_skor:=((pos_skor-(-1*ZipKoof[mm].zskor_A2))/(-1*ZipKoof[mm].zskor_B2-
                                  (-1*ZipKoof[mm].zskor_A2)));end;

  if (pos_skor > (-1*ZipKoof[mm].zskor_B2)) and (pos_skor<=ZipKoof[mm].zskor_C2) then
  begin my_norm_skor:=((ZipKoof[mm].zskor_C2-pos_skor)/(ZipKoof[mm].zskor_C2-
                              ZipKoof[mm].zskor_B2)); end;

  if pos_skor > ZipKoof[mm].zskor_C2 then  begin my_norm_skor:=0; end;

     F_Arhiv.ind_norm_skor.Caption:=formatFloat('0.00',(my_norm_skor));
 (*------------------------------------------*)
  if pos_skor <= ZipKoof[mm].zskor_A3 then begin my_bol_skor:=0; end;
  if (pos_skor > ZipKoof[mm].zskor_A3) and (pos_skor<=ZipKoof[mm].zskor_B3) then
   begin  my_bol_skor:=((pos_skor-ZipKoof[mm].zskor_A3)/(ZipKoof[mm].zskor_B3-
                                 ZipKoof[mm].zskor_A3));  end;
  if pos_skor >ZipKoof[mm].zskor_B3 then begin my_bol_skor:=1; end;

    F_Arhiv.ind_bol_skor.Caption:=formatFloat('0.00',(my_bol_skor));
      (*------------------------------------------*)
    

    zTablica(0);
    Vib_jach:=0;
    num_jach_prinad:=0;

    my_min1:=0;
    my_min2:=0;
    my_min3:=0;
    my_min4:=0;
    my_min5:=0;
    my_min6:=0;
    my_min7:=0;
    my_min8:=0;
    my_min9:=0;
    (*    +   *)

  (* 1 *)   if (my_mal_otkl > 0) and (my_mal_skor > 0) then
  begin Vib_jach:=Vib_jach+1; num_jach_prinad:=num_jach_prinad+1;
    if (my_mal_otkl >my_mal_skor ) then my_min1:=my_mal_skor
    else  my_min1:=my_mal_otkl; end;

  (* 2 *)   if (my_mal_otkl > 0) and (my_norm_skor > 0) then
  begin Vib_jach:=Vib_jach+2;num_jach_prinad:=num_jach_prinad+1;
   if (my_mal_otkl >my_norm_skor ) then my_min2:=my_norm_skor
    else  my_min2:=my_mal_otkl; end;


  (* 3 *)   if (my_mal_otkl > 0) and (my_bol_skor > 0) then
  begin Vib_jach:=Vib_jach+4;num_jach_prinad:=num_jach_prinad+1;
   if (my_mal_otkl >my_bol_skor ) then my_min3:=my_bol_skor
    else  my_min3:=my_mal_otkl; end;


  (*------------------------------------------*)

  (* 4 *)   if (my_norm_otkl > 0) and (my_mal_skor > 0) then
  begin Vib_jach:=Vib_jach+8;num_jach_prinad:=num_jach_prinad+1;
   if (my_norm_otkl >my_mal_skor ) then my_min4:=my_mal_skor
    else  my_min4:=my_norm_otkl; end;


  (* 5 *)   if (my_norm_otkl > 0) and (my_norm_skor > 0) then
  begin Vib_jach:=Vib_jach+16;num_jach_prinad:=num_jach_prinad+1;
   if (my_norm_otkl >my_norm_skor ) then my_min5:=my_norm_skor
    else  my_min5:=my_norm_otkl; end;


  (* 6 *)   if (my_norm_otkl > 0) and (my_bol_skor > 0) then
  begin Vib_jach:=Vib_jach+32;num_jach_prinad:=num_jach_prinad+1;
   if (my_norm_otkl >my_bol_skor ) then my_min6:=my_bol_skor
    else  my_min6:=my_norm_otkl; end;


  (*------------------------------------------*)

  (* 7 *)   if (my_bol_otkl > 0) and (my_mal_skor > 0) then
  begin Vib_jach:=Vib_jach+64;num_jach_prinad:=num_jach_prinad+1;
   if (my_bol_otkl >my_mal_skor ) then my_min7:=my_mal_skor
    else  my_min7:=my_bol_otkl; end;


  (* 8 *)   if (my_bol_otkl > 0) and (my_norm_skor > 0) then
  begin Vib_jach:=Vib_jach+128;num_jach_prinad:=num_jach_prinad+1;
   if (my_bol_otkl >my_norm_skor ) then my_min8:=my_norm_skor
    else  my_min8:=my_bol_otkl; end;


  (* 9 *)   if (my_bol_otkl > 0) and (my_bol_skor > 0) then
  begin Vib_jach:=Vib_jach+256;num_jach_prinad:=num_jach_prinad+1;
   if (my_bol_otkl >my_bol_skor ) then my_min9:=my_bol_skor
    else  my_min9:=my_bol_otkl; end;


     zTablica(Vib_jach);

{**********    *************}
  for num:=1 to 20 do begin jach_T[ num ]:=0; jach_My[ num ]:=0;
                            ja_T_rez[num]:=0; ja_My_rez[num]:=0; end;

//      jach_My[] ,jach_T[]      

  num:=0;
  if (Vib_jach and 1)=1 then begin  num:=num+1;
  jach_My[ num ]:= my_min1; jach_T[ num ]:=ZipKoof[mm].m1z;
                              end;

  if (Vib_jach and 2)=2 then  begin num:=num+1;
  jach_My[ num ]:= my_min2; jach_T[ num ]:=ZipKoof[mm].m2z;
                              end;

  if (Vib_jach and 4)=4 then  begin num:=num+1;
  jach_My[ num ]:= my_min3; jach_T[ num ]:=ZipKoof[mm].m3z;
                              end;

  if (Vib_jach and 8)=8 then  begin num:=num+1;
  jach_My[ num ]:= my_min4; jach_T[ num ]:=ZipKoof[mm].m4z;
                              end;

  if (Vib_jach and 16)=16 then  begin num:=num+1;
  jach_My[ num ]:= my_min5; jach_T[ num ]:=ZipKoof[mm].m5z;
                               end;

  if (Vib_jach and 32)=32 then  begin num:=num+1;
  jach_My[ num ]:= my_min6; jach_T[ num ]:=ZipKoof[mm].m6z;
                               end;

  if (Vib_jach and 64)=64 then  begin num:=num+1;
  jach_My[ num ]:= my_min7; jach_T[ num ]:=ZipKoof[mm].m7z;
                                end;

  if (Vib_jach and 128)=128 then  begin num:=num+1;
  jach_My[ num ]:= my_min8; jach_T[ num ]:=ZipKoof[mm].m8z;
                                end;

  if (Vib_jach and 256)=256 then  begin num:=num+1;
  jach_My[ num ]:= my_min9; jach_T[ num ]:=ZipKoof[mm].m9z;
                               end;

   (*********************************************)

    //////    Fazzyfik


  (* 1 ------------------------------------------*)
(**)  if jach_T[1]=jach_T[2] then    (*  1 = 2 *)

  (* 2 ------------------------------------------*)
  (***)         if jach_T[1]=jach_T[3] then       (*  1 = 2 = 3 *)

  (* 3 ------------------------------------------*)
 (****)             if jach_T[1]=jach_T[4] then    (*  1 = 2 = 3 = 4 * 1*)
                        begin
                         max := jach_My[1];
                         for ii:=2 to 4 do begin
                         if max < jach_My[ii] then max:= jach_My[ii];
                                          end;
                                           ja_My_rez[1]:=max;
                        end
          (****)    else   (*  1 = 2 = 3 <> 4 *  2*)
                       begin
               max := jach_My[1];
                         for ii:=2 to 3 do begin
                         if max < jach_My[ii] then max:= jach_My[ii];
                                          end;
                             ja_My_rez[1]:=max;         ja_T_rez[1]:=jach_T[1];
                             ja_My_rez[2]:=jach_My[4]; ja_T_rez[2]:=jach_T[4];
                        end
     (* ------------------------------------------*)
    (***)   else     (* 4 ? 1 = 2 <> 3 ? 4 *)
      begin

             if jach_T[3]= jach_T[4] then
           begin     (* 4 <> 1 = 2 <> 3 = 4 * 3 *)
                  (*-----------------------------------*)
                                     if jach_My[1]> jach_My[2] then
                                          begin  ja_My_rez[1]:=jach_My[1];
                                                 ja_T_rez[1]:=jach_T[1];
                                           end
                                     else

                                           begin  ja_My_rez[1]:=jach_My[2];
                                                  ja_T_rez[1]:=jach_T[2];
                                           end;
                   (*-----------------------------------*)
                   (***-------------------------------***)
                                    if jach_My[3]> jach_My[4] then
                                           begin  ja_My_rez[2]:=jach_My[3];
                                                  ja_T_rez[2]:=jach_T[3];
                                           end
                                     else

                                           begin  ja_My_rez[2]:=jach_My[4];
                                                  ja_T_rez[2]:=jach_T[4];
                                           end;
                   (***-------------------------------***)
            end
                else  (* 4 ? 1 = 2 <> 3 <> 4 *)
            begin
                                  if jach_T[1]= jach_T[4] then   (* 4=1=2<>3<>4 * 4 *)
                    begin
                   (***-------------------------------***)
                                     max:=jach_My[1];
                                           if jach_My[2]> max then     max:=jach_My[2];
                                           if jach_My[4]> max then     max:=jach_My[4];

                                         //  begin
                                                  ja_My_rez[1]:=max;
                                                  ja_T_rez[1]:=jach_T[1];
                                                  ja_My_rez[2]:=jach_My[3];
                                                  ja_T_rez[2]:=jach_T[3];
                                         //  end;
                     end
                                    else
                                              (* 4<>1=2<>3<>4 * 5 *)

                    begin
                                           (*-----------------------------------*)
                                     if jach_My[1]> jach_My[2] then
                                          begin  ja_My_rez[1]:=jach_My[1];
                                                 ja_T_rez[1]:=jach_T[1];
                                           end
                                     else

                                           begin  ja_My_rez[1]:=jach_My[2];
                                                  ja_T_rez[1]:=jach_T[2];
                                            end;
                   (*-----------------------------------*)

                                                  ja_My_rez[2]:=jach_My[3];
                                                  ja_T_rez[2]:=jach_T[3];
                                                  ja_My_rez[3]:=jach_My[4];
                                                  ja_T_rez[3]:=jach_T[4];
                    end;
             end;

         end
 (* 3 ------------------------------------------*)

else


  (******************** 1 *************************)

  if jach_T[2]=jach_T[3] then   (* 4 ? 1 <> 2 = 3 ? 4 *)
  begin
  (*************-------------------------------*)
      (*****)  if jach_T[2]=jach_T[4] then       (* 4 <> 1 <> 2 = 3 = 4 *  6 *)
  (* 3 ------------------------------------------*)
          begin
                           max:=jach_My[2];
                           if jach_My[3]> max then     max:=jach_My[2];
                           if jach_My[4]> max then     max:=jach_My[4];

                                           begin
                                                  ja_My_rez[1]:=jach_My[1];
                                                  ja_T_rez[1]:=jach_T[1];
                                                  ja_My_rez[2]:=max;
                                                  ja_T_rez[2]:=jach_T[2];

                                           end;
          end
      (*****)        else   (* 4 ? 1 = 2 = 3 <> 4 *)
          begin
       (* ------------------------------------------*)
    (***-***)         if jach_T[1]=jach_T[4] then    (* 4= 1 <> 2 = 3 <> 4 * 7 *)
                begin
                       (*-----------------------------------*)
                    if jach_My[1]> jach_My[4] then
                                          begin  ja_My_rez[1]:=jach_My[1];
                                                 ja_T_rez[1]:=jach_T[1];
                                           end
                                     else

                                           begin  ja_My_rez[1]:=jach_My[4];
                                                  ja_T_rez[1]:=jach_T[4];
                                           end;
                   (*-----------------------------------*)
                   (***-------------------------------***)
                    if jach_My[2]> jach_My[3] then
                                           begin  ja_My_rez[2]:=jach_My[2];
                                                  ja_T_rez[2]:=jach_T[2];
                                           end
                                     else

                                           begin  ja_My_rez[2]:=jach_My[3];
                                                  ja_T_rez[2]:=jach_T[3];
                                           end;
                   (***-------------------------------***)
                end
    (*  ------------------------------------------*)
     (***-***)        else    (* 4<> 1 <> 2 = 3 <> 4 *  8 *)

                begin
                       (*-----------------------------------*)
                    if jach_My[2]> jach_My[3] then
                                          begin  ja_My_rez[2]:=jach_My[2];
                                                 ja_T_rez[2]:=jach_T[2];
                                           end
                                     else

                                           begin  ja_My_rez[2]:=jach_My[3];
                                                  ja_T_rez[2]:=jach_T[3];
                                           end;
                   (*-----------------------------------*)
                   (***-------------------------------***)
                                                  ja_My_rez[1]:=jach_My[1];
                                                  ja_T_rez[1]:=jach_T[1];
                                                  ja_My_rez[3]:=jach_My[4];
                                                  ja_T_rez[3]:=jach_T[4];

                   (***-------------------------------***)
                 end;
             end;
   end

 (******************** 2 *************************)


   else         (* 4 ? 1 <> 2 <> 3 ? 4 *)


 begin
(*----*) if jach_T[3]= jach_T[4] then    (* 4 ? 1 <> 2 <> 3 = 4 *)
       begin
   (**-*-**) if jach_T[4]= jach_T[1] then     (* 4 = 1 <> 2 <> 3 = 4 *  9 *)
                  (*-----------------------------------*)
                   begin
                                           max:=jach_My[1];
                           if jach_My[3]> max then     max:=jach_My[3];
                           if jach_My[4]> max then     max:=jach_My[4];

                                           ja_My_rez[1]:=max;
                                           ja_T_rez[1]:=jach_T[1];
                                           ja_My_rez[2]:=jach_My[2];
                                           ja_T_rez[2]:=jach_T[2];
                   end
  (**-*-**)  else            (* 4 <> 1 <> 2 <> 3 = 4 * 10 *)
                   begin
                           if jach_My[3]> jach_My[4] then
                                           begin  ja_My_rez[3]:=jach_My[3];
                                                  ja_T_rez[3]:=jach_T[3];
                                           end
                                     else

                                           begin  ja_My_rez[3]:=jach_My[4];
                                                  ja_T_rez[3]:=jach_T[4];
                                           end;
                   (***-------------------------------***)
                                           ja_My_rez[1]:=jach_My[1];
                                           ja_T_rez[1]:=jach_T[1];
                                           ja_My_rez[2]:=jach_My[2];
                                           ja_T_rez[2]:=jach_T[2];

                     end;
        end

(*----*) else
   // .........................................
        begin
       (* ------------------------------------------*)
             if jach_T[1]=jach_T[4] then    (* 4= 1 <> 2 <> 3 <> 4 * 11 *)
                        begin
                       (*-----------------------------------*)
                    if jach_My[1]> jach_My[4] then
                                          begin  ja_My_rez[1]:=jach_My[1];
                                                 ja_T_rez[1]:=jach_T[1];
                                           end
                                     else

                                           begin  ja_My_rez[1]:=jach_My[4];
                                                  ja_T_rez[1]:=jach_T[4];
                                           end;
                   (*-----------------------------------*)

                                                  ja_My_rez[2]:=jach_My[2];
                                                  ja_T_rez[2]:=jach_T[2];
                                                  ja_My_rez[3]:=jach_My[3];
                                                  ja_T_rez[3]:=jach_T[3];
                         end


    (*  ------------------------------------------*)
               else    (* 4<> 1 <> 2 <> 3 <> 4 *  12 *)

                      begin
                                                 ja_My_rez[1]:=jach_My[1];
                                                 ja_T_rez[1]:=jach_T[1];
                                                 ja_My_rez[2]:=jach_My[2];
                                                 ja_T_rez[2]:=jach_T[2];
                                                 ja_My_rez[3]:=jach_My[3];
                                                 ja_T_rez[3]:=jach_T[3];
                                                 ja_My_rez[4]:=jach_My[4];
                                                 ja_T_rez[4]:=jach_T[4];

                        end;
          end

 end;
(* 1 ------------------------------------------*)

P_temp:=0;

for  ii := 1 to 4 do
begin
  case (ja_T_rez[ ii]) of
   1: P_temp:=P_temp + ZipKoof[mm].zvih_1* ja_My_rez[ii];  //  
   2: P_temp:=P_temp + ZipKoof[mm].zvih_1* ja_My_rez[ii];// 
   3: P_temp:=P_temp + ZipKoof[mm].zvih_1* ja_My_rez[ii]; // 
   4: P_temp:=P_temp + ZipKoof[mm].zvih_1* ja_My_rez[ii];// 
   5: P_temp:=P_temp + ZipKoof[mm].zvih_1* ja_My_rez[ii];//  
   6: P_temp:=P_temp + ZipKoof[mm].zvih_1* ja_My_rez[ii];//  
   7: P_temp:=P_temp + ZipKoof[mm].zvih_1* ja_My_rez[ii];//  
   8: P_temp:=P_temp + ZipKoof[mm].zvih_1* ja_My_rez[ii];//  
   9: P_temp:=P_temp + ZipKoof[mm].zvih_1* ja_My_rez[ii];//  
   end;
 end;

  P:= P_temp /(ja_My_rez[1]+ja_My_rez[2]+ja_My_rez[3]+ja_My_rez[4]);

  (***********************************)
  


   U_out:=P+U;
   zFuzzy:=0.427*U_out;

   
end;

end.
